import 'package:xdatabase/xdatabase.dart';

import 'models.dart';

class LogBeean implements Bean<Log> {
  Log? log;
  LogBeean(this.log);
  @override
  Map<String, dynamic> asMap() {
    if (log == null) {
      throw UnsupportedError('Not Initialized');
    }
    return {
      'local_id': log!.localId,
      'auther_id': log!.autherId,
      'user_id': log!.userId,
      'body': log!.body,
      'create_ts': log!.createTs,
      'update_ts': log!.updateTs,
    };
  }

  @override
  Log fromMap(Map<String, dynamic> map) {
    final log = Log();
    log.localId = map['local_id'];
    log.autherId = map['auther_id'];
    log.userId = map['user_id'];
    log.body = map['body'];
    log.createTs = map['create_ts'];
    log.updateTs = map['update_ts'];
    return log;
  }

  @override
  Future<int> delete(String statement, QueryAble conn) {
    return Orm<Log>(conn).query(statement).delete(this);
  }

  @override
  Future<int> deleteByPk(QueryAble conn) {
    return Orm<Log>(conn).deleteByPk(this);
  }

  @override
  Future<int> insert(QueryAble conn) {
    return Orm<Log>(conn).insert(this);
  }

  @override
  Future<List<Log>> select(String statement, QueryAble conn) {
    return Orm<Log>(conn).query(statement).fetch(this, all: log == null);
  }

  @override
  Future<Log?> selectByPk(QueryAble conn) {
    return Orm<Log>(conn).byPrimary(this);
  }

  @override
  Future<int> update(String statement, QueryAble conn) {
    return Orm<Log>(conn).query(statement).update(this);
  }

  @override
  Future<int> updateByPK(QueryAble conn) {
    return Orm<Log>(conn).updateByPk(this);
  }
}

const String declarationMap =
    '''{"log_table":{"tableName":"log_table","className":"Log","fields":[{"propertyName":"localId","fieldName":"local_id","fieldType":"VARCHAR(36)","primary":true,"mark":""},{"propertyName":"autherId","fieldName":"auther_id","fieldType":"VARCHAR(66)","primary":false,"mark":"作者ID"},{"propertyName":"userId","fieldName":"user_id","fieldType":"VARCHAR(66)","primary":false,"mark":"作者ID"},{"propertyName":"body","fieldName":"body","fieldType":"TEXT","primary":false,"mark":"内容"},{"propertyName":"createTs","fieldName":"create_ts","fieldType":"INT","primary":false,"mark":"创建时间"},{"propertyName":"updateTs","fieldName":"update_ts","fieldType":"INT","primary":false,"mark":"修改时间"}],"indexes":[{"indexName":"_idx_log_ts","fields":["local_id","create_ts"]}],"uniqueIndexes":[]}}''';
