import 'package:xdatabase/xdatabase.dart';

@Table('log_table')
@Index(name: '_idx_log_ts', columns: ['local_id', 'create_ts'])
class Log {
  @Field(type: 'VARCHAR(36)', primary: true)
  late String localId = '';
  @Field(type: 'VARCHAR(66)', mark: '作者ID')
  late String autherId = '';
  @Field(type: 'VARCHAR(66)', mark: '作者ID')
  late String userId = '';
  @Field(type: 'TEXT', mark: '内容')
  late String body = '';
  @Field(type: 'INT', mark: '创建时间')
  late int createTs = 0;
  @Field(type: 'INT', mark: '修改时间')
  late int updateTs = 0;
  Log();
  Log.make(
      {required this.localId,
      required this.autherId,
      required this.body,
      required this.createTs});

  @override
  String toString() {
    return 'id:$localId auth:$autherId, body:$body ts:$createTs';
  }
}
